# Class VulkanPipelineShaderStageCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanPipelineShaderStageCreateInfo

All Implemented Interfaces:
  `VulkanPipelineShaderStageCreateInfoType`

public final class VulkanPipelineShaderStageCreateInfo extends Object implements VulkanPipelineShaderStageCreateInfoType

See Also:
  - "VkPipelineShaderStageCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanPipelineShaderStageCreateInfo.Builder`
  Builds instances of type `VulkanPipelineShaderStageCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanPipelineShaderStageCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanPipelineShaderStageCreateInfo`.
  `static VulkanPipelineShaderStageCreateInfo`
  `copyOf(VulkanPipelineShaderStageCreateInfoType instance)`
  Creates an immutable copy of a `VulkanPipelineShaderStageCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanPipelineShaderStageCreateInfo` that have equal attribute values.
  `Set<VulkanPipelineShaderStageCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `stage`, `module`, `shaderEntryPoint`, `specializationInfo`.
  `VulkanShaderModuleType`
  `module()`
  `static VulkanPipelineShaderStageCreateInfo`
  `of(Iterable<VulkanPipelineShaderStageCreateFlag> flags, VulkanShaderStageFlag stage, VulkanShaderModuleType module, String shaderEntryPoint, Optional<? extends VulkanSpecializationMap> specializationInfo)`
  Construct a new immutable `VulkanPipelineShaderStageCreateInfo` instance.
  `static VulkanPipelineShaderStageCreateInfo`
  `of(Set<VulkanPipelineShaderStageCreateFlag> flags, VulkanShaderStageFlag stage, VulkanShaderModuleType module, String shaderEntryPoint, Optional<VulkanSpecializationMap> specializationInfo)`
  Construct a new immutable `VulkanPipelineShaderStageCreateInfo` instance.
  `String`
  `shaderEntryPoint()`
  `Optional<VulkanSpecializationMap>`
  `specializationInfo()`
  `VulkanShaderStageFlag`
  `stage()`
  `String`
  `toString()`
  Prints the immutable value `VulkanPipelineShaderStageCreateInfo` with attribute values.
  `final VulkanPipelineShaderStageCreateInfo`
  `withFlags(VulkanPipelineShaderStageCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineShaderStageCreateInfo`
  `withFlags(Iterable<VulkanPipelineShaderStageCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineShaderStageCreateInfo`
  `withModule(VulkanShaderModuleType value)`
  Copy the current immutable object by setting a value for the `module` attribute.
  `final VulkanPipelineShaderStageCreateInfo`
  `withShaderEntryPoint(String value)`
  Copy the current immutable object by setting a value for the `shaderEntryPoint` attribute.
  `final VulkanPipelineShaderStageCreateInfo`
  `withSpecializationInfo(VulkanSpecializationMap value)`
  Copy the current immutable object by setting a present value for the optional `specializationInfo` attribute.
  `final VulkanPipelineShaderStageCreateInfo`
  `withSpecializationInfo(Optional<? extends VulkanSpecializationMap> optional)`
  Copy the current immutable object by setting an optional value for the `specializationInfo` attribute.
  `final VulkanPipelineShaderStageCreateInfo`
  `withStage(VulkanShaderStageFlag value)`
  Copy the current immutable object by setting a value for the `stage` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanPipelineShaderStageCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanPipelineShaderStageCreateInfoType`
    Returns:
      Flags reserved for future use

  - ### stage

    public VulkanShaderStageFlag stage()
    Specified by:
      `stage` in interface `VulkanPipelineShaderStageCreateInfoType`
    Returns:
      A single pipeline stage.

  - ### module

    public VulkanShaderModuleType module()
    Specified by:
      `module` in interface `VulkanPipelineShaderStageCreateInfoType`
    Returns:
      A shader module containing the shader for the stage.

  - ### shaderEntryPoint

    public String shaderEntryPoint()
    Specified by:
      `shaderEntryPoint` in interface `VulkanPipelineShaderStageCreateInfoType`
    Returns:
      The entry point name of the shader for this stage.

  - ### specializationInfo

    public Optional<VulkanSpecializationMap> specializationInfo()
    Specified by:
      `specializationInfo` in interface `VulkanPipelineShaderStageCreateInfoType`
    Returns:
      The optional specialization info

  - ### withFlags

    public final VulkanPipelineShaderStageCreateInfo withFlags(VulkanPipelineShaderStageCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanPipelineShaderStageCreateInfo withFlags(Iterable<VulkanPipelineShaderStageCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withStage

    public final VulkanPipelineShaderStageCreateInfo withStage(VulkanShaderStageFlag value)
    Copy the current immutable object by setting a value for the `stage` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for stage
    Returns:
      A modified copy of the `this` object

  - ### withModule

    public final VulkanPipelineShaderStageCreateInfo withModule(VulkanShaderModuleType value)
    Copy the current immutable object by setting a value for the `module` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for module
    Returns:
      A modified copy of the `this` object

  - ### withShaderEntryPoint

    public final VulkanPipelineShaderStageCreateInfo withShaderEntryPoint(String value)
    Copy the current immutable object by setting a value for the `shaderEntryPoint` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for shaderEntryPoint
    Returns:
      A modified copy of the `this` object

  - ### withSpecializationInfo

    public final VulkanPipelineShaderStageCreateInfo withSpecializationInfo(VulkanSpecializationMap value)
    Copy the current immutable object by setting a present value for the optional `specializationInfo` attribute.
    Parameters:
      `value` - The value for specializationInfo
    Returns:
      A modified copy of `this` object

  - ### withSpecializationInfo

    public final VulkanPipelineShaderStageCreateInfo withSpecializationInfo(Optional<? extends VulkanSpecializationMap> optional)
    Copy the current immutable object by setting an optional value for the `specializationInfo` attribute. A shallow reference equality check is used on unboxed optional value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - A value for specializationInfo
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanPipelineShaderStageCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `stage`, `module`, `shaderEntryPoint`, `specializationInfo`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanPipelineShaderStageCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanPipelineShaderStageCreateInfo of(Set<VulkanPipelineShaderStageCreateFlag> flags, VulkanShaderStageFlag stage, VulkanShaderModuleType module, String shaderEntryPoint, Optional<VulkanSpecializationMap> specializationInfo)
    Construct a new immutable `VulkanPipelineShaderStageCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `stage` - The value for the `stage` attribute
      `module` - The value for the `module` attribute
      `shaderEntryPoint` - The value for the `shaderEntryPoint` attribute
      `specializationInfo` - The value for the `specializationInfo` attribute
    Returns:
      An immutable VulkanPipelineShaderStageCreateInfo instance

  - ### of

    public static VulkanPipelineShaderStageCreateInfo of(Iterable<VulkanPipelineShaderStageCreateFlag> flags, VulkanShaderStageFlag stage, VulkanShaderModuleType module, String shaderEntryPoint, Optional<? extends VulkanSpecializationMap> specializationInfo)
    Construct a new immutable `VulkanPipelineShaderStageCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `stage` - The value for the `stage` attribute
      `module` - The value for the `module` attribute
      `shaderEntryPoint` - The value for the `shaderEntryPoint` attribute
      `specializationInfo` - The value for the `specializationInfo` attribute
    Returns:
      An immutable VulkanPipelineShaderStageCreateInfo instance

  - ### copyOf

    public static VulkanPipelineShaderStageCreateInfo copyOf(VulkanPipelineShaderStageCreateInfoType instance)
    Creates an immutable copy of a `VulkanPipelineShaderStageCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanPipelineShaderStageCreateInfo instance

  - ### builder

    public static VulkanPipelineShaderStageCreateInfo.Builder builder()
    Creates a builder for `VulkanPipelineShaderStageCreateInfo`.

         VulkanPipelineShaderStageCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanPipelineShaderStageCreateFlag) // flags elements
            .setStage(com.io7m.jcoronado.api.VulkanShaderStageFlag) // required stage
            .setModule(com.io7m.jcoronado.api.VulkanShaderModuleType) // required module
            .setShaderEntryPoint(String) // required shaderEntryPoint
            .setSpecializationInfo(VulkanSpecializationMap) // optional specializationInfo
            .build();

    Returns:
      A new VulkanPipelineShaderStageCreateInfo builder